SystemOrganization addCategory: #'OB-Tests-Web'!

TestCase subclass: #OBAjaxMessageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBAjaxMessageTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 00:07'!
test01ArgumentsCanBeExplicit
	| message |
	message _ OBAjaxMessage
				receiver: 'abc'
				selector: #test:with:
				arguments: #(a b).
	self assert: message arguments = #(a b)! !

!OBAjaxMessageTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 00:07'!
test02ArgumentsCanBeLazy
	| message |
	message _ OBAjaxMessage
				receiver: 'abc'
				selector: #test:with:
				arguments: [Array with: #a with: #b].
	self assert: message arguments = #(a b)! !

TestCase subclass: #OBHtmlGenerationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBHtmlGenerationTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2007 14:37'!
expectedWindowHtml
	^ '<html><head><title>browser</title><script src="http://localhost/ob/link.js"></script><script src="http://localhost/ob/widgets.js"></script><link rel="stylesheet" href="http://localhost/ob/browser.css" type="text/css" /></head><body><div id="w1xelxppx5lx1uakej5rf573gh" class="Root root"></div><script>Widget.init("w1xelxppx5lx1uakej5rf573gh"); </script></body></html>'! !

!OBHtmlGenerationTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2007 14:39'!
expectedWindowWithChildHtml
	^ '<html><head><title>browser</title><script src="http://localhost/ob/link.js"></script><script src="http://localhost/ob/widgets.js"></script><link rel="stylesheet" href="http://localhost/ob/browser.css" type="text/css" /></head><body><div id="w1xelxppx5lx1uakej5rf573gh" class="Root root"><div id="w1xelxppx5lx1uakej5rf573gh" class="Text vertical" style="top: 40%; height: 60%"></div></div><script>Widget.init("w1xelxppx5lx1uakej5rf573gh"); Widget.get("w1xelxppx5lx1uakej5rf573gh").update({"bold": false, "text": "This is a tast"});</script></body></html>'! !

!OBHtmlGenerationTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:46'!
id
	^ OBWebIdentifier random: (Random seed: 32445)! !

!OBHtmlGenerationTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:47'!
test01EmptyWindow
	| widget |
	widget _ OBWebWindow id: self id model: self.
	self assert: widget html = self expectedWindowHtml.
	! !

!OBHtmlGenerationTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 00:32'!
test02WindowWithChild
	| widget actual expected |
	widget _ OBWebWindow id: self id model: self.
	widget addChild: (OBWebText id: self id model: self).
	actual _ widget html.
	expected _ self expectedWindowWithChildHtml.
	self assert: actual = expected
	! !

!OBHtmlGenerationTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 00:30'!
text
	^ 'This is a tast'! !

TestCase subclass: #OBWebIdentifierTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebIdentifierTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 10:56'!
test01DefaultSize
	| id |
	id _ OBWebIdentifier new.
	self assert: id size = 16! !

!OBWebIdentifierTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 21:02'!
test02Print
	| id |
	id _ OBWebIdentifier random: (Random seed: 32655).
	self assert: id printString = 'w5hrndt4hbpbym40b4s1p5qw5e'! !

TestCase subclass: #OBWebListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebListTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 11:56'!
createList
	^ OBWebList 
		id: (OBWebIdentifier random: (Random seed: 43222))
		model: self! !

!OBWebListTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 12:05'!
list
	^ #('Alpha' 'Beta' 'Gamma')! !

!OBWebListTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 12:05'!
selection
	^ 2! !

!OBWebListTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 21:01'!
test01InitializesWithListAndSelection
	| list init |
	list _ self createList.
	init _ String streamContents: [:s | list jsInitializeOn: s].
	self assert: init = 'Widget.get("wan18u9s6ubfe77f1ug6yo74uv").update({"selection": 1, "items": ["Alpha", "Beta", "Gamma"]});'! !

TestCase subclass: #OBWebMenuItemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebMenuItemTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2007 00:22'!
testSerialization
	| item json |
	item _ OBWebMenuItem
			label: 'test'
			target: self
			selector: #yourself.
	json _ String streamContents: [:stream | item jsonWriteOn: stream].
	self assert: json = '{"label": "test", "isEnabled": true}'! !

TestCase subclass: #OBWebMenuTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebMenuTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2007 14:40'!
testSerialization
	| menu json |
	menu _ OBWebMenu seed: 3559543.
	menu add: 'test' target: self selector: #yourself.
	json _ String streamContents: [:s | menu jsonWriteOn: s].
	self assert: json = '{"id": "w9cq4xll13c3bh4r1fn31lvsgr", "items": [{"label": "test", "isEnabled": true}]}'! !

TestCase subclass: #OBWebScrollerTest
	instanceVariableNames: 'columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2007 20:28'!
announcer
	^ OBAnnouncer new! !

!OBWebScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2007 20:21'!
buildScroller
	| builder |
	builder _ OBWebBuilder new.
	^ builder columnPanel: self with: [columns do: [:ea | ea buildOn: builder]]! !

!OBWebScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2007 20:32'!
columns
	^ columns! !

!OBWebScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2007 14:36'!
sizing
	^ columns size! !

!OBWebScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2007 16:57'!
testPushPane
	| scroller request |
	columns _ OrderedCollection new.
	3 timesRepeat: [columns add: (OBColumn inPanel: self)].
	scroller _ self buildScroller.
	columns add: (OBColumn inPanel: self).
	[self changed: #columns]
		on: OBInteractionRequest
		do: [:req | request _ req].
	self assert: (request isKindOf: OBAjaxResponse).
	self assert: request message selector = 'push'.
	self assert: scroller children size = 4.! !

TestCase subclass: #OBWebTextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebTextTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 00:19'!
createText
	^ OBWebText
		id: (OBWebIdentifier random: (Random seed: 43222))
		model: self! !

!OBWebTextTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2007 14:41'!
test01InitializesWithTextAndSelection
	| list init |
	list _ self createText.
	init _ String streamContents: [:s | list jsInitializeOn: s].
	self assert: init = 'Widget.get("wan18u9s6ubfe77f1ug6yo74uv").update({"bold": false, "text": "This is a test"});'! !

!OBWebTextTest methodsFor: 'emulating' stamp: 'cwp 5/21/2007 00:28'!
text
	^ 'This is a test'! !

TestCase subclass: #OBWebWindowTest
	instanceVariableNames: 'id delivered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebWindowTest methodsFor: 'emulating' stamp: 'cwp 10/25/2006 19:06'!
addWithAllChildrenTo: anIdentityDictionary 
	anIdentityDictionary at: self identifier put: self! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 12:15'!
createWidget
	^ OBWebWindow 
		id: (OBWebIdentifier random: (Random seed: 43222))
		model: self! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 18:59'!
handleMessage: aJsonObject
	delivered _ aJsonObject! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 13:52'!
id
	^ id! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 13:52'!
identifier
	^ id printString! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 18:53'!
setUp
	id _ OBWebIdentifier seed: 44355.
	! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 21:01'!
test01InitializesWithWidgetInit
	| list init |
	list _ self createWidget.
	init _ String streamContents: [:s | list jsInitializeOn: s].
	self assert: init = 'Widget.init("wan18u9s6ubfe77f1ug6yo74uv"); '! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2006 20:12'!
test02DispatchesMessagesById
	| window message |
	window _ self createWidget.
	window addChild: self.
	message _ OBAjaxMessage
				receiver: self identifier
				selector: #ackMessage
				arguments: #().
	window processMessage: message.
	self assert: delivered == message
				! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/20/2007 23:59'!
test03DoesntQueueDuplicateMessages
	| window message |
	window _ self createWidget.
	message _ OBAjaxMessage
				receiver: self identifier
				selector: #ackMessage
				arguments: #().
	window queueMessage: message.
	window queueMessage: message copy.
	self assert: window flushQueue size = 1! !

OBBuilderTest subclass: #OBWebBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebBuilderTest methodsFor: 'building' stamp: 'cwp 3/13/2007 22:29'!
builder
	^ OBWebBuilder new! !

!OBWebBuilderTest methodsFor: 'tests' stamp: 'cwp 3/13/2007 22:14'!
tests01BrowserCreatesWindow
	| widget |
	widget _ self buildWindow.
	self assert: (widget isKindOf: OBWebWindow).
	self assert: widget model == model.! !

!OBWebBuilderTest methodsFor: 'tests' stamp: 'cwp 3/13/2007 22:19'!
tests02BrowserAddsPanels
	| widget |
	widget _ self buildWindow.
	self assert: widget children size = 2.
	self assert: (widget children first isKindOf: OBWebScroller).
	self assert: (widget children second isKindOf: OBWebText).! !

!OBWebBuilderTest methodsFor: 'tests' stamp: 'cwp 3/13/2007 22:21'!
tests03ColumnPanelAddsColumns
	| widget |
	widget _ self buildNavigationPanel.
	self assert: widget children size = 4.
	widget children do: [:ea | self assert: (ea isKindOf: OBWebPane)].! !

!OBWebBuilderTest methodsFor: 'tests' stamp: 'cwp 10/24/2006 10:39'!
tests04ColumnAddsList
	| builder column |
	builder _ OBWebBuilder new.
	column _ self columnWithFilter.
	column buildOn: builder.
	self assert: (builder root isKindOf: OBWebPane).
	self assert: (builder root children first isKindOf: OBWebList)! !
